!--
!----------------------------------------------------------------------
!     Copyright (c) 2019 SPMODEL Development Group.
!----------------------------------------------------------------------
!表題  wa_interpolate_mpi_module_sypack
!
!  spml/wa_interpolate_mpi_module_sypack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_mpi_module_sypack の下部モジュールであり, スペクトル法による
!  補間計算のための Fortran90 関数を提供する. 
!
!  補間計算の方法については doc/wa_module.tex を参照のこと. 
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!履歴  2019/05/01  竹広真一
!
!++
module ua_interpolate_mpi_module_sypack
  !
  !=  ua_interpolate_mpi_module_sypack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: ua_interpolate_mpi_module_sypack.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wa_interpolate_mpi_module_sypack モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール wa_mpi_module_sypack の下部モジュールであり, スペクトル法による
  !  補間計算のための Fortran90 関数を提供する. 
  !
  !  補間計算の方法については doc/wa_module.tex を参照のこと. 
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_interpolate_mpi_module_sypack
  use ua_base_mpi_module_sypack, only : nc, nmc, km, kc, wb_ua
  implicit none
  private

  public b_Interpolate_ua                        ! 補間関数

  interface b_Interpolate_ua
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! その球面調和変換係数 ua_data から補間計算する
     !
     ! 入力する緯度経度座標は, 
     !       １点, 経度1点緯度複数点, 経度複数点緯度1点, 経度緯度複数点
     ! の 4 種類
     !
     module procedure b_Interpolate_array00_ua
  end interface

  contains

  !--------------- 補間計算 -----------------
    function b_Interpolate_array00_ua(ua_data,alon,alat)
      !
      ! 緯度 alat, 経度 alon における関数値を
      ! その球面調和変換係数 ua_data から補間計算する
      !
      real(8), intent(IN) :: ua_data(nmc,km)        ! スペクトルデータ
      real(8), intent(IN) :: alon                   ! 補間する位置(経度)
      real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
      real(8) :: b_Interpolate_array00_ua(kc)       ! 補間した値

      real(8) :: wb_data(nc,kc)
      integer :: k
      
      wb_data = wb_ua(ua_data)

      do k=1,kc
         b_Interpolate_array00_ua(k) = Interpolate_w(wb_data(:,k),alon,alat)
      end do

    end function b_Interpolate_array00_ua

!!$    function Interpolate_array00_u(u_data,alon,alat)
!!$      !
!!$      ! 緯度 alat, 経度 alon における関数値を
!!$      ! その球面調和変換係数 ua_data から補間計算する
!!$      !
!!$      real(8), intent(IN) :: u_data(nmc)            ! スペクトルデータ
!!$      real(8), intent(IN) :: alon                   ! 補間する位置(経度)
!!$      real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
!!$      real(8) :: Interpolate_array00_u              ! 補間した値
!!$
!!$      Interpolate_array00_u = Interpolate_array00_w(w_u(u_data))
!!$
!!$    end function Interpolate_array00_u

end module ua_interpolate_mpi_module_sypack
